# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing
import pydantic
import typing_extensions
from .fallback_rime_ai_voice_id import FallbackRimeAiVoiceId
from ..core.serialization import FieldMetadata
from .fallback_rime_ai_voice_model import FallbackRimeAiVoiceModel
from .chunk_plan import ChunkPlan
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class FallbackRimeAiVoice(UniversalBaseModel):
    provider: typing.Literal["rime-ai"] = pydantic.Field(default="rime-ai")
    """
    This is the voice provider that will be used.
    """

    voice_id: typing_extensions.Annotated[FallbackRimeAiVoiceId, FieldMetadata(alias="voiceId")] = pydantic.Field()
    """
    This is the provider-specific ID that will be used.
    """

    model: typing.Optional[FallbackRimeAiVoiceModel] = pydantic.Field(default=None)
    """
    This is the model that will be used. Defaults to 'v1' when not specified.
    """

    speed: typing.Optional[float] = pydantic.Field(default=None)
    """
    This is the speed multiplier that will be used.
    """

    chunk_plan: typing_extensions.Annotated[typing.Optional[ChunkPlan], FieldMetadata(alias="chunkPlan")] = (
        pydantic.Field(default=None)
    )
    """
    This is the plan for chunking the model output before it is sent to the voice provider.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
