# This file was auto-generated by Fern from our API Definition.

from ..core.pydantic_utilities import UniversalBaseModel
import typing_extensions
import typing
from ..core.serialization import FieldMetadata
import pydantic
from ..core.pydantic_utilities import IS_PYDANTIC_V2


class TrieveKnowledgeBaseVectorStoreCreatePlan(UniversalBaseModel):
    file_ids: typing_extensions.Annotated[typing.List[str], FieldMetadata(alias="fileIds")] = pydantic.Field()
    """
    These are the file ids that will be used to create the vector store. To upload files, use the `POST /files` endpoint.
    """

    target_splits_per_chunk: typing_extensions.Annotated[
        typing.Optional[float], FieldMetadata(alias="targetSplitsPerChunk")
    ] = pydantic.Field(default=None)
    """
    This is an optional field which allows you to specify the number of splits you want per chunk. If not specified, the default 20 is used. However, you may want to use a different number.
    """

    split_delimiters: typing_extensions.Annotated[
        typing.Optional[typing.List[str]], FieldMetadata(alias="splitDelimiters")
    ] = pydantic.Field(default=None)
    """
    This is an optional field which allows you to specify the delimiters to use when splitting the file before chunking the text. If not specified, the default [.!?\n] are used to split into sentences. However, you may want to use spaces or other delimiters.
    """

    rebalance_chunks: typing_extensions.Annotated[typing.Optional[bool], FieldMetadata(alias="rebalanceChunks")] = (
        pydantic.Field(default=None)
    )
    """
    This is an optional field which allows you to specify whether or not to rebalance the chunks created from the file. If not specified, the default true is used. If true, Trieve will evenly distribute remainder splits across chunks such that 66 splits with a target_splits_per_chunk of 20 will result in 3 chunks with 22 splits each.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
